/* att_table.h */

/*	Attribute and font usage structure.
	
	The structure is used by headers, notes, etc. to keep track of
	the font/attrs needed for themselves. The global, printer_state, is
	updated by all the different routines so that everyone can know
	the current state of the printer--this info is used to select
	only the needed attrs/font when things get printed. 
*/

typedef struct att_table
{
	char cfont,
	sizemod,
	aselect[NUM_ATTRIBUTES];
}Att_table;

Att_table *getbodyatts(void);
int getdksize(int n, Att_table *att);
int getcsize(KCHAR c, Att_table *att);
int fillbuff(KCHAR *buff, KCHAR *buffend, int maxlen, int indentsize, int centerid, Att_table *startatts, int mode);
void do_dumb_printer(Att_table *atts);
void printline(KCHAR *buff, Att_table *call_atts);
