/* attributes.c

   Define attribute sequences, print attrs
   
*/

#include "vpt.h"
#include "codes.h"

static struct
{
	u_char	schange;
	Codes	*acodes;
}attrcodes[NUM_ATTRIBUTES*2];		/* 1st 36 for ONcodes, 2nd 36 for OFF */

/*	============================================================
	Tokenize an attribute command
*/

void
tokattr(KCHAR n, KCHAR mode)
{
	int t;
	
	if((t=getregnum(n))==-1) error("Unknown embedded attribute");
	
	switch(mode)
	{
		case '-':
			returnkey(t+INT_ATTROFF);
			break;
		
		case '+':
			returnkey(t+INT_ATTRON);
			break;
		
		case '*':
			returnkey(t+INT_ATTRON);
			returnkey(INT_WORDATT);
			break;
			
		default:
			break;	/* should never happen!!! */
	}
}

/*	============================================================
	Define an attribute sequence
*/

void
setattr(char atname, char onoff)
{
	int atnum;
	KCHAR c;
	u_char sizechg=0;
	
	/* convert the name (n=0..9, a..z) to buffer offset (t=0..35) */
	
	if( (atnum=getregnum(atname) )==-1)
		error("Illegal attribute name");
	
	if(onoff=='-')	atnum+=NUM_ATTRIBUTES;
	
	skipequal();
	
	if(onoff=='+')
	{
		if((c=getnonb())=='*') sizechg=getval(0); 
		else
		{
			returnkey(c);
			sizechg=0;
		}
	}
	if(sizechg==1) sizechg=0;
	
	free(attrcodes[atnum].acodes);
	if((attrcodes[atnum].acodes=calloc(sizeof(attrcodes[0].acodes),1))==NULL)
		terminate("Attribute buffer overflow");
	setcodes(&attrcodes[atnum].acodes, "attribute");
	attrcodes[atnum].schange=sizechg;
}

/*	============================================================
	Return the size change for the specified attribute
*/

int
getasize(int t)
{
	return attrcodes[t].schange;
}

/*	============================================================
	Send a sequence of attribute on/off codes to output
	
	buff - attribute number (0..35)
	onoff - 1==on, 0==off
*/

void
sendAcodes(int n, int onoff)
{
	if(printpg)
	{
		if(onoff==0) n+=NUM_ATTRIBUTES;
		docodes(attrcodes[n].acodes);
	}
}
