/* returnkey.c */

#include "vpt.h"

#define KEYBUFSIZE 4000
#define STACKSIZE 15

static int	keybz,
			kscount;
static u_char keybuff[KEYBUFSIZE];
static u_char *kbuff=keybuff;
static u_char *kbuffend=keybuff+KEYBUFSIZE;

static struct
{
	short kcount;
	u_char *kptr;
}kstack[STACKSIZE];

// function prototypes

static void kerr(void);


static void
kerr(void)
{
	terminate("Keyboard stack error--contact Bob");
}

void
pushkbuff(void)
{
	kstack[kscount].kcount=keybz;
	kstack[kscount++].kptr=kbuff;
	kbuff+=keybz;
	keybz=0;
	if(kscount>=STACKSIZE-1) kerr();
}

void
pullkbuff(void)
{
	if(!kscount) kerr();
	keybz=kstack[--kscount].kcount;
	kbuff=kstack[kscount].kptr;
}


/* Get a key from returned key stack and return */

KCHAR
getretkey(void)
{
	KCHAR c=0;
	
	if(keybz)					/* pull from retkey buffer */
	{
		if( (c=(KCHAR)kbuff[--keybz]) == INT_TOKEN)
		{
			if(!keybz) kerr();
			c=0x100+(KCHAR)kbuff[--keybz];
		}
	}
	return c;
}

/*	============================================================
	Return key routines
*/

/*	return a string. This string might have tokens in it, but they are
	represented as two byte sequences (INT_TOKEN,value) so no problems
	are presented.
*/

void
returnstr(char *s)
{
	char *p=s;
	
	incomment++;
	
	p=strend(p);				  /* move p to end of string+1  */
	
	while(--p>=s) returnkey((KCHAR)*p);  /* return chars to beginning  */
	
	incomment--;
}

void
returnkey(KCHAR c)
{
	if(c!=INT_SSPACE)	 /* ignore small spaces */
	{
		kbuff[keybz++]=(char)c;
		
		if(c>0x100) kbuff[keybz++]=(char)INT_TOKEN;
		else if(c==control && !incomment) kbuff[keybz++]=(char)c;
		
		if(&kbuff[keybz]>=kbuffend) terminate("Input buffer overflow");
	}
}

